MYSQLIMPORT(1)

NAME
mysqlimport - a data import program

SYNOPSIS

mysqlimport [options] db_name textfile1 ...

DESCRIPTION

The mysqlimport client provides a command-line interface to the LOAD DATA INFILE SQL statement. Most options to mysqlimport correspond directly to clauses of LOAD DATA INFILE syntax. See Section 2.5, “LOAD DATA INFILE Syntax”.

Invoke mysqlimport like this:

    shell> mysqlimport [options] db_name textfile1 [textfile2 ...]

For each text file named on the command line, mysqlimport strips any extension from the filename and uses the result to determine the name of the table into which to import the file's contents. For example, files named patient.txt, patient.text, and patient all would be imported into a table named patient.

mysqlimport supports the following options:

Table 4.6. mysqlimport Option Reference

Format | Config File | Description | Introduced
--columns=column_list | columns | This option takes a comma-separated list of column names as its value |
--fields-enclosed-by=string | fields-enclosed-by | This option has the same meaning as the corresponding clause for LOAD DATA INFILE |
--fields-escaped-by | fields-escaped-by | This option has the same meaning as the corresponding clause for LOAD DATA INFILE |
--fields-optionally-enclosed-by=string | fields-optionally-enclosed-by | This option has the same meaning as the corresponding clause for LOAD DATA INFILE |
--fields-terminated-by=string | fields-terminated-by | -- This option has the same meaning as the corresponding clause for LOAD DATA INFILE |
--force | force | Continue even if an SQL error occurs |
-f |  |  |
--help |  | Display help message and exit |
-? |  |  |
--host=host_name | host | Connect to the MySQL server on the given host |
-h host_name |  |  |
-c columns_list |  |  |
--ignore | ignore | See the description for the --replace option |
-i |  |  |
--ignore-lines=N | ignore-lines | Ignore the first N lines of the data file |
--lines-terminated-by=string | lines-terminated-by | This option has the same meaning as the corresponding clause for LOAD DATA INFILE |
--local | local | Read input files locally from the client host |
-L |  |  |
--lock-tables | lock-tables | Lock all tables for writing before processing any text files |
-l |  |  |
--low-priority | low-priority | Use LOW_PRIORITY when loading the table. |
--password[=password] | password | The password to use when connecting to the server |
--compress | compress | Compress all information sent between the client and the server |
-p[password] |  |  |
--port=port_num | port | The TCP/IP port number to use for the connection |
-P port_num |  |  |
--protocol={TCP|SOCKET|PIPE|MEMORY} | protocol | The connection protocol to use |
--replace | replace | The --replace and --ignore options control handling of input rows that duplicate existing rows on unique key values |
--silent | silent | Produce output only when errors occur |
-s |  |  |
--socket=path | socket | For connections to localhost |
-S path |  |  |
--ssl-ca=file_name | ssl-ca | The path to a file that contains a list of trusted SSL CAs |
-C |  |  |
--ssl-capath=directory_name | ssl-capath | The path to a directory that contains trusted SSL CA certificates in PEM format |
--ssl-cert=file_name | ssl-cert | The name of the SSL certificate file to use for establishing a secure connection |
--ssl-cipher=cipher_list | ssl-cipher | A list of allowable ciphers to use for SSL encryption |
--ssl-key=file_name | ssl-key | The name of the SSL key file to use for establishing a secure connection |
--ssl-verify-server-cert | ssl-verify-server-cert | The server's Common Name value in its certificate is verified against the hostname used when connecting to the server |
--user=user_name, | user | The MySQL username to use when connecting to the server |
-u user_name |  |  |
--verbose |  | Verbose mode |
-v |  |  |
--version |  | Display version information and exit |
-# [debug_options] | debug | Write a debugging log |
-V |  |  |
--debug[=debug_options] |  |  |
--default-character-set=charset_name | default-character-set | Use charset_name as the default character set |
--delete | delete | Empty the table before importing the text file |
-D |  |  |

•   --help, -?

    Display a help message and exit.

•   --character-sets-dir=path

    The directory where character sets are installed. See Section 2, “The Character Set Used for Data and Sorting”.

•   --columns=column_list, -c column_list

    This option takes a comma-separated list of column names as its value. The order of the column names indicates how to match data file columns with table columns.

•   --compress, -C

    Compress all information sent between the client and the server if both support compression.

•   --debug[=debug_options], -# [debug_options]

    Write a debugging log. The debug_options string often is 'd:t:o,file_name'.

•   --default-character-set=charset_name

    Use charset_name as the default character set. See Section 2, “The Character Set Used for Data and Sorting”.

•   --delete, -D

    Empty the table before importing the text file.

•   --fields-terminated-by=..., --fields-enclosed-by=..., --fields-optionally-enclosed-by=..., --fields-escaped-by=...

    These options have the same meaning as the corresponding clauses for LOAD DATA INFILE. See Section 2.5, “LOAD DATA INFILE Syntax”.

•   --force, -f

    Ignore errors. For example, if a table for a text file does not exist, continue processing any remaining files. Without --force, mysqlimport exits if a table does not exist.

•   --host=host_name, -h host_name

    Import data to the MySQL server on the given host. The default host is localhost.

•   --ignore, -i

    See the description for the --replace option.

•   --ignore-lines=N

    Ignore the first N lines of the data file.

•   --lines-terminated-by=...

    This option has the same meaning as the corresponding clause for LOAD DATA INFILE. For example, to import Windows files that have lines terminated with carriage return/linefeed pairs, use --lines-terminated-by="\r\n". (You might have to double the backslashes, depending on the escaping conventions of your command interpreter.) See Section 2.5, “LOAD DATA INFILE Syntax”.

•   --local, -L

    Read input files locally from the client host.

•   --lock-tables, -l

    Lock all tables for writing before processing any text files. This ensures that all tables are synchronized on the server.

•   --low-priority

    Use LOW_PRIORITY when loading the table. This affects only storage engines that use only table-level locking (MyISAM, MEMORY, MERGE).

•   --password[=password], -p[password]

    The password to use when connecting to the server. If you use the short option form (-p), you cannot have a space between the option and the password. If you omit the password value following the --password or -p option on the command line, you are prompted for one.

    Specifying a password on the command line should be considered insecure. See Section 5.6, “Keeping Your Password Secure”.

•   --port=port_num, -P port_num

    The TCP/IP port number to use for the connection.

•   --protocol={TCP|SOCKET|PIPE|MEMORY}

    The connection protocol to use.

•   --replace, -r

    The --replace and --ignore options control handling of input rows that duplicate existing rows on unique key values. If you specify --replace, new rows replace existing rows that have the same unique key value. If you specify --ignore, input rows that duplicate an existing row on a unique key value are skipped. If you do not specify either option, an error occurs when a duplicate key value is found, and the rest of the text file is ignored.

•   --silent, -s

    Silent mode. Produce output only when errors occur.

•   --socket=path, -S path

    For connections to localhost, the Unix socket file to use, or, on Windows, the name of the named pipe to use.

•   --ssl*

    Options that begin with --ssl specify whether to connect to the server via SSL and indicate where to find SSL keys and certificates. See Section 5.7.3, “SSL Command Options”.

•   --user=user_name, -u user_name

    The MySQL username to use when connecting to the server.

•   --verbose, -v

    Verbose mode. Print more information about what the program does.

•   --version, -V

    Display version information and exit.

Here is a sample session that demonstrates use of mysqlimport:

    shell> mysql -e 'CREATE TABLE imptest(id INT, n VARCHAR(30))' test
    shell> ed
    a
    100     Max Sydow
    101     Count Dracula
    w imptest.txt
    32
    q
    shell> od -c imptest.txt
    0000000   1   0   0  \t   M   a   x       S   y   d   o   w  \n   1   0
    0000020   1  \t   C   o   u   n   t       D   r   a   c   u   l   a  \n
    0000040
    shell> mysqlimport --local test imptest.txt
    test.imptest: Records: 2  Deleted: 0  Skipped: 0  Warnings: 0
    shell> mysql -e 'SELECT * FROM imptest' test
    +------+---------------+
    | id   | n             |
    +------+---------------+
    |  100 | Max Sydow     |
    |  101 | Count Dracula |
    +------+---------------+

COPYRIGHT

Copyright 2007-2008 MySQL AB

This documentation is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.

This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA or see http://www.gnu.org/licenses/.

SEE ALSO
For more information, please refer to the MySQL Reference Manual, which may already be installed locally and which is also available online at http://dev.mysql.com/doc/.

AUTHOR
MySQL AB (http://www.mysql.com/).